import * as _loadable_component from '@loadable/component';
import { DefaultComponent, Options, ExtraComponentProps } from '@loadable/component';
import React from 'react';

declare type LoadFn<Props> = (props: Props) => Promise<DefaultComponent<Props>>;
declare type LoadOptions<Props> = Options<Props> | undefined;
interface WrapperProps {
    wrapperCss?: {
        string: string | number;
    };
}
interface ObserverOptions {
    root?: Element | Document;
    rootMargin?: string;
    threshold?: number | number[];
}
declare type InitObserverTuple = [Map<Element, Function>, IntersectionObserver | undefined];

declare function initComponent<Props>(loadFn: LoadFn<Props>, opts: LoadOptions<Props>): _loadable_component.LoadableComponent<Props> | {
    (props: Props & WrapperProps & ExtraComponentProps): JSX.Element;
    preload(): void;
    load(): Promise<React.ComponentType<Props>>;
};

declare function initObserver(observerOptions?: ObserverOptions): InitObserverTuple;

export { initComponent as default, initObserver };
